Scriptname _CNO_MainScript extends Quest

_CNO_MCM Property Mcm Auto
_CNO_RegisterOutfits Property RegScr Auto

Form[] ModArmorList

LeveledItem Property LvL_1 Auto
LeveledItem[] Property LvL_1_Sub Auto
Outfit Property Outfit_1 Auto
LeveledItem Property LvL_2 Auto
LeveledItem[] Property LvL_2_Sub Auto
Outfit Property Outfit_2 Auto
LeveledItem Property LvL_3 Auto
LeveledItem[] Property LvL_3_Sub Auto
Outfit Property Outfit_3 Auto
LeveledItem Property LvL_4 Auto
LeveledItem[] Property LvL_4_Sub Auto
Outfit Property Outfit_4 Auto
LeveledItem Property LvL_5 Auto
LeveledItem[] Property LvL_5_Sub Auto
Outfit Property Outfit_5 Auto

LeveledItem Property LvL_11 Auto
LeveledItem[] Property LvL_11_Sub Auto
Outfit Property Outfit_11 Auto
LeveledItem Property LvL_12 Auto
LeveledItem[] Property LvL_12_Sub Auto
Outfit Property Outfit_12 Auto
LeveledItem Property LvL_13 Auto
LeveledItem[] Property LvL_13_Sub Auto
Outfit Property Outfit_13 Auto
LeveledItem Property LvL_14 Auto
LeveledItem[] Property LvL_14_Sub Auto
Outfit Property Outfit_14 Auto
LeveledItem Property LvL_15 Auto
LeveledItem[] Property LvL_15_Sub Auto
Outfit Property Outfit_15 Auto

LeveledItem Property LvL_21 Auto
LeveledItem[] Property LvL_21_Sub Auto
Outfit Property Outfit_21 Auto
LeveledItem Property LvL_22 Auto
LeveledItem[] Property LvL_22_Sub Auto
Outfit Property Outfit_22 Auto
LeveledItem Property LvL_23 Auto
LeveledItem[] Property LvL_23_Sub Auto
Outfit Property Outfit_23 Auto
LeveledItem Property LvL_24 Auto
LeveledItem[] Property LvL_24_Sub Auto
Outfit Property Outfit_24 Auto
LeveledItem Property LvL_25 Auto
LeveledItem[] Property LvL_25_Sub Auto
Outfit Property Outfit_25 Auto


Outfit Property DummyOutfit Auto

Spell Property DetectSpell Auto
Spell Property ChangeCellSpell Auto

Faction Property BanditFaction Auto
Faction Property ForswornFaction Auto
Faction Property VampireFaction Auto

Event OnInit()
;	RegisterForKey(16) ; Q
;	RegisterForKey(34) ; G
;	RegisterForKey(35) ; H
	Game.GetPlayer().AddSpell(DetectSpell, False)
	Game.GetPlayer().AddSpell(ChangeCellSpell, False)
	RegisterForModEvent("CNO_PlayerChangeCell", "OnCNO_PlayerChangeCell")
EndEvent

Bool ChangeDone = False

Event OnUpdate()
	if StorageUtil.FormListCount(none, "CNO_ScheduledActorList") > 0
		Actor TempActor = StorageUtil.FormListGet(none, "CNO_ScheduledActorList", 0) as Actor
		if TempActor
			Outfit TempOutfit = StorageUtil.GetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor) as Outfit
			if TempOutfit
				CNO_Log("[CNO] - OnUpdate - TempActor: " + TempActor.GetFormID())
				TempActor.SetOutfit(DummyOutfit)
				TempActor.SetOutfit(TempOutfit)
				StorageUtil.UnsetFormValue(none, "CNO_ScheduledActorOutfit_" + TempActor)
				StorageUtil.FormListRemove(none, "CNO_ScheduledActorList", TempActor)
				RegisterForSingleUpdate(0.5)
			else
				RegisterForSingleUpdate(0.5)
			endif
		else
			RegisterForSingleUpdate(0.5)
		endif
	endif
EndEvent

Event OnCNO_PlayerChangeCell(string eventName, string strArg, float somefloat = 1.0, Form sender)
	if Game.GetPlayer().IsInInterior() && Mcm.InteriorOnly == True
		Cell TempCell = Game.GetPlayer().GetParentCell()
		Int ArrayLength = TempCell.GetNumRefs(62)
		While ArrayLength > 0
			ArrayLength -= 1
			ChangeDone = False
			Actor TempActor = TempCell.GetNthRef(ArrayLength, 62) as actor
			if TempActor != Game.GetPlayer() && !TempActor.IsDead() && TempActor.GetActorBase().GetSex() == 1
				if TempActor.IsInFaction(BanditFaction) && TempActor.GetFactionRank(BanditFaction) != 99
					Int TotalWeight = Mcm.BanditOutfitChance_1 + Mcm.BanditOutfitChance_2 + Mcm.BanditOutfitChance_3 + Mcm.BanditOutfitChance_4 + Mcm.BanditOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_1) && Mcm.BanditOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 1")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_1)
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_2) && Mcm.BanditOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 2")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_2)
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_3) && Mcm.BanditOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 3")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_3)
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.BanditOutfitChance_4) && Mcm.BanditOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 4")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_4)
							ChangeDone = True
						else
							TempRandInt -= Mcm.BanditOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.BanditOutfitIndex_5 != -1 && Mcm.BanditOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 5")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_5)
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(ForswornFaction) && TempActor.GetFactionRank(ForswornFaction) != 99
					Int TotalWeight = Mcm.ForswornOutfitChance_1 + Mcm.ForswornOutfitChance_2 + Mcm.ForswornOutfitChance_3 + Mcm.ForswornOutfitChance_4 + Mcm.ForswornOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_1) && Mcm.ForswornOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 11")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_11)
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_2) && Mcm.ForswornOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 12")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_12)
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_3) && Mcm.ForswornOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 13")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_13)
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.ForswornOutfitChance_4) && Mcm.ForswornOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 14")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_14)
							ChangeDone = True
						else
							TempRandInt -= Mcm.ForswornOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.ForswornOutfitIndex_5 != -1 && Mcm.ForswornOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 15")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_15)
							ChangeDone = True
						endif
					endif
				elseif TempActor.IsInFaction(VampireFaction) && TempActor.GetFactionRank(VampireFaction) != 99
					Int TotalWeight = Mcm.VampireOutfitChance_1 + Mcm.VampireOutfitChance_2 + Mcm.VampireOutfitChance_3 + Mcm.VampireOutfitChance_4 + Mcm.VampireOutfitChance_5
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TotalWeight: " + TotalWeight)
					Int TempRandInt = Utility.RandomInt(0, TotalWeight)
					CNO_Log("[CNO] - OnCNO_PlayerChangeCell - TempRandInt: " + TempRandInt)
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_1) && Mcm.VampireOutfitIndex_1 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 21")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_21)
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_1
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_2) && Mcm.VampireOutfitIndex_2 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 22")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_22)
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_2
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_3) && Mcm.VampireOutfitIndex_3 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 23")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_23)
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_3
						endif
					endif
					if ChangeDone == False
						if (TempRandInt <= Mcm.VampireOutfitChance_4) && Mcm.VampireOutfitIndex_4 != -1
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 24")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_24)
							ChangeDone = True
						else
							TempRandInt -= Mcm.VampireOutfitChance_4
						endif
					endif
					if ChangeDone == False
						if Mcm.VampireOutfitIndex_5 != -1 && Mcm.VampireOutfitChance_4 != 0
							CNO_Log("[CNO] - OnCNO_PlayerChangeCell - PickOutfit: 25")
							TempActor.SetOutfit(DummyOutfit)
							TempActor.SetOutfit(Outfit_25)
							ChangeDone = True
						endif
					endif
				endif
			endif
		endwhile
	endif
EndEvent

;Event OnKeyDown(Int KeyCode)
;	if KeyCode == 16
;		ModArmorList = GameData.GetAllArmor("Melodic Merge.esp")
;		Debug.Trace("[CNO] - ArmorFound: " + ModArmorList.Length)
;		Int ArrayLength = ModArmorList.Length
;		StorageUtil.FormListCopy(None, "CNO_ModdedArmorFormList", ModArmorList)
;		Debug.Trace("[CNO] - StorageUtil: " + StorageUtil.FormListCount(none, "CNO_ModdedArmorFormList"))
;	elseif KeyCode == 35
;		Cell c = Game.GetPlayer().GetParentCell()
;		Int NumRefs = c.GetNumRefs(62)
;		while NumRefs
;			NumRefs -= 1
;			Actor TempActor = c.GetNthRef(NumRefs, 62) as actor
;			if TempActor != Game.GetPlayer()
;				TempActor.SetOutfit(DummyOutfit)
;				TempActor.SetOutfit(Outfit_1)
;			endif
;		endwhile
;	elseif KeyCode == 34
;		Game.GetPlayer().AddSpell(DetectSpell, False)
;		ObjectReference CrosshairRef = Game.GetCurrentCrosshairRef() as ObjectReference
;		if CrosshairRef
;			if CrosshairRef as Actor
;				(CrosshairRef as Actor).SetOutfit(DummyOutfit)
;				(CrosshairRef as Actor).SetOutfit(Outfit_1)
;			endif
;		endif
;	endif
;	
;EndEvent

Function BuildOutfit(String FactionName, Int SlotIndex, String OutfitName)
	if FactionName == "Bandits"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_1.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_1_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_1.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_1.Revert()
				LeveledItem TempLeveledItem = Lvl_1_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_1.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_2.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_2_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_2.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_2.Revert()
				LeveledItem TempLeveledItem = Lvl_2_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_2.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_3.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_3_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_3.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_3.Revert()
				LeveledItem TempLeveledItem = Lvl_3_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_3.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_4.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_4_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_4.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_4.Revert()
				LeveledItem TempLeveledItem = Lvl_4_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_4.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_5.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_5_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_5.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_5.Revert()
				LeveledItem TempLeveledItem = Lvl_5_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_5.AddForm(TempLeveledItem, 1, 1)
			endif
		endif
	elseif FactionName == "Forsworn"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_11.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_11_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_11.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_11.Revert()
				LeveledItem TempLeveledItem = Lvl_11_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_11.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_12.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_12_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_12.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_12.Revert()
				LeveledItem TempLeveledItem = Lvl_12_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_12.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_13.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_13_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_13.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_13.Revert()
				LeveledItem TempLeveledItem = Lvl_13_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_13.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_14.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_14_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_14.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_14.Revert()
				LeveledItem TempLeveledItem = Lvl_14_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_14.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_15.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_15_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_15.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_15.Revert()
				LeveledItem TempLeveledItem = Lvl_15_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_15.AddForm(TempLeveledItem, 1, 1)
			endif
		endif
	elseif FactionName == "Vampire"
		if SlotIndex == 1
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_21.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_21_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_21.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_21.Revert()
				LeveledItem TempLeveledItem = Lvl_21_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_21.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 2
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_22.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_22_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_22.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_22.Revert()
				LeveledItem TempLeveledItem = Lvl_22_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_22.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 3
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_23.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_23_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_23.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_23.Revert()
				LeveledItem TempLeveledItem = Lvl_23_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_23.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 4
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_24.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_24_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_24.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_24.Revert()
				LeveledItem TempLeveledItem = Lvl_24_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_24.AddForm(TempLeveledItem, 1, 1)
			endif
		elseif SlotIndex == 5
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitName)
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName)
				LvL_25.Revert()
				Int ArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitSet_" + OutfitName)
				If ArrayLength > 5
					ArrayLength = 5
				endif
				CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength: " + ArrayLength)
				While ArrayLength > 0
					ArrayLength -= 1
					LeveledItem TempLeveledItem = LvL_25_Sub[ArrayLength]
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " TempLeveledItem: " + TempLeveledItem.GetFormID())
					TempLeveledItem.Revert()
					String Outfit2 = StorageUtil.StringListGet(none, "CNO_InstalledOutfitSet_" + OutfitName, ArrayLength)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " Outfit2: " + Outfit2)
					Int ArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + Outfit2)
					CNO_Log("[CNO] - BuildOutfit - Outfitset: " + OutfitName + " ArrayLength2: " + ArrayLength2)
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + Outfit2, ArrayLength2), 1, 1)
					endWhile
					LvL_25.AddForm(TempLeveledItem, 1, 1)
				endwhile
			else
				LvL_25.Revert()
				LeveledItem TempLeveledItem = Lvl_25_Sub[0]
				TempLeveledItem.Revert()
				Int ArrayLength = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + OutfitName)
				while ArrayLength > 0
					ArrayLength -= 1
					TempLeveledItem.AddForm(StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + OutfitName, ArrayLength), 1, 1)
				endwhile
				LvL_25.AddForm(TempLeveledItem, 1, 1)
			endif
		endif
	endif
EndFunction

Function StartMod()
;	CreateRegOutfits()
	Int ModIndex = Game.GetModCount()
	while ModIndex > 0
		ModIndex -= 1
		String ModName = Game.GetModName(ModIndex)
		Int ArrayLength = StorageUtil.StringListCount(none, "CNO_ModNameFragmentList")
		While ArrayLength > 0
			ArrayLength -= 1
			String ModNameFragment = StorageUtil.StringListGet(none, "CNO_ModNameFragmentList", ArrayLength)
			if StringUtil.Find(ModName, ModNameFragment) != -1
				CNO_Log("[CNO] - Checking Mod: " + ModName)
				ModArmorList = GameData.GetAllArmor(ModName)
				StorageUtil.FormListCopy(None, "CNO_ModdedArmorFormList", ModArmorList)
				SetArmorIDs()
				ArrayLength = 0
			endif
		endwhile
	endwhile
	SetOutfits()
	Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_InstalledOutfitList")
	While ArrayLength2 > 0
		ArrayLength2 -= 1
		String TempOutfit = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", ArrayLength2)
		if StorageUtil.StringListHas(none, "CNO_AddOutfitForRegistration", TempOutfit)
			ClearTemp(TempOutfit)
		endif
	endwhile
	StorageUtil.StringListClear(none, "CNO_RegisteringOutfitList")
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
	StorageUtil.StringListClear(none, "CNO_RegisteringArmorNames")
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
	Int CleanArray = StorageUtil.StringListCount(none, "CNO_StringGarbageBin")
	while CleanArray > 0
		CleanArray -= 1
		CNO_Log("[CNO] - Clean: " + StorageUtil.StringListGet(none, "CNO_StringGarbageBin", CleanArray))
	endwhile
	
	Int TestArrayLength = StorageUtil.StringListCount(none, "CNO_InstalledOutfitList")
	while TestArrayLength > 0
		TestArrayLength -= 1
		String TestOutfitName = StorageUtil.StringListGet(none, "CNO_InstalledOutfitList", TestArrayLength)
		Int TestArrayLength2 = StorageUtil.FormListCount(none, "CNO_InstalledOutfit_" + TestOutfitName)
		CNO_Log("[CNO] - " + TestOutfitName + " : " + TestArrayLength2)
		While TestArrayLength2 > 0
			TestArrayLength2 -= 1
			Armor TestOutfitArmorName = StorageUtil.FormListGet(none, "CNO_InstalledOutfit_" + TestOutfitName, TestArrayLength2) as Armor
			CNO_Log("[CNO] - " + TestOutfitName + " : " + TestOutfitArmorName.GetName())
		endwhile
	endwhile
	ModArmorList = new form[1]
	debug.messagebox("[CNO] Scan complete")
EndFunction

Function RegisterOutfitsExternal()
	String[] TempStr = new string[9]
	TempStr = MiscUtil.FilesInFolder("Data/SKSE/Plugins/CNO", ".json")
	StorageUtil.StringListCopy(none, "CNO_ExternalFileList", TempStr)
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_ExternalFileList")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempString = StorageUtil.StringListGet(none, "CNO_ExternalFileList", ArrayLength)
		if StringUtil.Find(TempString, "CNO_Register") == -1
			StorageUtil.StringListRemove(none, "CNO_ExternalFileList", TempString)
		else
			Int MainContainerID = JValue.readFromFile("Data/SKSE/Plugins/CNO/" + TempString)
			JDB.SetObj("CNO_TempJOutfitList", MainContainerID)
			Int JContOutfitListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_RegisterOutfit")
			JDB.SetObj("CNO_TempJOutfit", JContOutfitListObject)
			Int JArrayLength = JArray.count(JContOutfitListObject)
			while JArrayLength > 0
				JArrayLength -= 1
				String JOutfitName = JArray.GetStr(JContOutfitListObject, JArrayLength)
				StorageUtil.StringListAdd(none, "CNO_AddOutfitForRegistration", JOutfitName, False)
				Int JContOutfitObject = JDB.solveObj(".CNO_TempJOutfitList." + JOutfitName)
				Int JArrayLength2 = JArray.count(JContOutfitObject)
				While JArrayLength2 > 0
					JArrayLength2 -= 1
					String JOutfitArmorName = JArray.GetStr(JContOutfitObject, JArrayLength2)
					StorageUtil.StringListAdd(none, JOutfitName, JOutfitArmorName, False)
				endwhile
			endwhile
			
			Int JContOutfitSetListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_RegisterOutfitSet")
			Int JArrayLength3 = JArray.count(JContOutfitSetListObject)
			While JArrayLength3 > 0
				JArrayLength3 -= 1
				String JOutfitSetName = JArray.GetStr(JContOutfitSetListObject, JArrayLength3)
				StorageUtil.StringListAdd(none, "CNO_AddOutfitSetForRegistration", JOutfitSetName, False)
				Int JContOutfitSetObject = JDB.solveObj(".CNO_TempJOutfitList." + JOutfitSetName)
				Int JArrayLength4 = JArray.count(JContOutfitSetObject)
				While JArrayLength4 > 0
					JArrayLength4 -= 1
					String JOutfitName = JArray.GetStr(JContOutfitSetObject, JArrayLength4)
					StorageUtil.StringListAdd(none, JOutfitSetName, JOutfitName, False)
				endwhile
			endwhile
			
			Int JContModNameListObject = JDB.solveObj(".CNO_TempJOutfitList.CNO_ModNameFragment")
			Int JArrayLength5 = JArray.count(JContModNameListObject)
			While JArrayLength5 > 0
				JArrayLength5 -= 1
				String JModNameFragment = JArray.GetStr(JContModNameListObject, JArrayLength5)
				StorageUtil.StringListAdd(none, "CNO_ModNameFragmentList", JModNameFragment, False)
			endwhile
		endif
	endwhile
EndFunction

Function RegisterOutfits()
	RegisterOutfitsExternal()
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_AddOutfitForRegistration")
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitName = StorageUtil.StringListGet(none, "CNO_AddOutfitForRegistration", ArrayLength)
		if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
			if !StorageUtil.StringListHas(none, "CNO_RegisteringOutfitList", OutfitName)
				Int ArrayLength2 = StorageUtil.StringListCount(none, OutfitName)
				while ArrayLength2 > 0
					ArrayLength2 -= 1
					String TempArmorString = StorageUtil.StringListGet(none, OutfitName, ArrayLength2)
					StorageUtil.StringListAdd(none, "CNO_RegisteringArmorNames", TempArmorString)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
					StorageUtil.StringListAdd(none, "CNO_RegisteringOutfit_" + OutfitName, TempArmorString)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
					StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitList", OutfitName)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
					StorageUtil.StringListAdd(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
						StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmor_" + TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_SupportedOutfitList", OutfitName, False)
				endwhile
			endif
		else
			CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName + " already registered")
		endif
	endwhile
	ArrayLength = StorageUtil.StringListCount(none, "CNO_AddOutfitSetForRegistration")
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitSetName = StorageUtil.StringListGet(none, "CNO_AddOutfitSetForRegistration", ArrayLength)
		if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitSetName)
			StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSetList", OutfitSetName, false)
				StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitSetList", OutfitSetName)
			Int ArrayLength2 = StorageUtil.StringListCount(none, OutfitSetName)
			while ArrayLength2 > 0
				ArrayLength2 -= 1
				String TempString = StorageUtil.StringListGet(none, OutfitSetName, ArrayLength2)
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, TempString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitSet_" + OutfitSetName)
				StorageUtil.StringListAdd(none, "CNO_SupportedOutfitSetList", OutfitSetName, False)
			endwhile
		endif
	endwhile
	debug.messagebox("[CNO] Registration complete")
EndFunction

Function RegisterOutfit(String OutfitName)
	if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
		if !StorageUtil.StringListHas(none, "CNO_RegisteringOutfitList", OutfitName)
			Int ArrayLength = StorageUtil.StringListCount(none, OutfitName)
			while ArrayLength > 0
				ArrayLength -= 1
				String TempArmorString = StorageUtil.StringListGet(none, OutfitName, ArrayLength)
				StorageUtil.StringListAdd(none, "CNO_RegisteringArmorNames", TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfit_" + OutfitName, TempArmorString)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
				StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitList", OutfitName)
					StorageUtil.StringListAdd(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
;				StorageUtil.SetStringValue(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
;					StorageUtil.StringListAdd(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorString)
				StorageUtil.StringListAdd(none, "CNO_RegisteringArmor_" + TempArmorString, OutfitName)
			endwhile
		endif
	else
		CNO_Log("[CNO] - RegisterOutfit - Outfit " + OutfitName + " already registered")
	endif
EndFunction

Function RegisterOutfitSet(String OutfitSetName)
	if !StorageUtil.StringListHas(none, "CNO_InstalledOutfitSetList", OutfitSetName)
		StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSetList", OutfitSetName, false)
		Int ArrayLength = StorageUtil.StringListCount(none, OutfitSetName)
		while ArrayLength > 0
			ArrayLength -= 1
			String TempString = StorageUtil.StringListGet(none, OutfitSetName, ArrayLength)
			StorageUtil.StringListAdd(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, TempString)
		endwhile
	endif
EndFunction

Function ClearTemp(String OutfitName)
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfit_" + OutfitName)
	While ArrayLength > 0
		ArrayLength -= 1
		String TempArmorName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfit_" + OutfitName, ArrayLength)
;		StorageUtil.UnSetStringValue(none, "CNO_RegisteringArmor_" + TempArmorName)
		StorageUtil.StringListRemove(none, "CNO_RegisteringArmor_" + TempArmorName, OutfitName)
		StorageUtil.StringListRemove(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorName)
		StorageUtil.StringListRemove(none, "CNO_RegisteringArmorNames", TempArmorName)
	endwhile
	StorageUtil.StringListClear(none, "CNO_RegisteringOutfit_" + OutfitName)
	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + OutfitName)
EndFunction

Function SetArmorIDs()
	if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
		return
	endif
	Int ArrayLength =  StorageUtil.FormListCount(none, "CNO_ModdedArmorFormList")
	While ArrayLength > 0
		if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
			ArrayLength = 0
		endif
		ArrayLength -= 1
		Armor TempArmor = StorageUtil.FormListGet(none, "CNO_ModdedArmorFormList", ArrayLength) as Armor
		if StorageUtil.StringListHas(none, "CNO_RegisteringArmorNames", TempArmor.GetName())
			CNO_Log("[CNO] - ArmorFound: " + TempArmor.GetName())
;			String OutfitName = StorageUtil.GetStringValue(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
			Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
			while ArrayLength2 > 0
				ArrayLength2 -= 1
				String OutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringArmor_" + TempArmor.GetName(), ArrayLength2)
				StorageUtil.UnsetStringValue(none, "CNO_RegisteringArmor_" + TempArmor.GetName())
				StorageUtil.FormListAdd(none, "CNO_InstalledOutfit_" + OutfitName, TempArmor, False)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitList", OutfitName, False)
				StorageUtil.StringListRemove(none, "CNO_RegisteringArmorNames", TempArmor.GetName())
			endwhile
			if StorageUtil.StringListCount(none, "CNO_RegisteringArmorNames") <= 0
				ArrayLength = 0
			endif
		endif
	endwhile
	
	
;	ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitList")
;	while ArrayLength > 0
;		ArrayLength -= 1
;		String TempOutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitList", ArrayLength)
;		Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringOutfit_" + TempOutfitName)
;		While ArrayLength2 > 0
;			ArrayLength2 -= 1
;			String TempArmorName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfit_" + TempOutfitName, ArrayLength2)
;;			StorageUtil.StringListClear(none, "CNO_RegisteringArmor_" + TempArmorName)
;;			StorageUtil.StringListRemove(none, "CNO_StringValGarbageBin", "CNO_RegisteringArmor_" + TempArmorName)
;		endwhile
;;		StorageUtil.StringListClear(none, "CNO_RegisteringOutfit_" + TempOutfitName)
;;		StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfit_" + TempOutfitName)
;	endwhile
;;	StorageUtil.StringListClear(none, "CNO_RegisteringOutfitList")
;;	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringOutfitList")
;;	StorageUtil.StringListClear(none, "CNO_RegisteringArmorNames")
;;	StorageUtil.StringListRemove(none, "CNO_StringGarbageBin", "CNO_RegisteringArmorNames")
EndFunction

Function SetOutfits()
	
	Int ArrayLength = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitSetList")
	CNO_Log("[CNO] - CNO_RegisteringOutfitSetList: " + ArrayLength)
	While ArrayLength > 0
		ArrayLength -= 1
		String OutfitSetName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitSetList", ArrayLength)
		CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName)
		Int ArrayLength2 = StorageUtil.StringListCount(none, "CNO_RegisteringOutfitSet_" + OutfitSetName)
		CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName + " ArrayLength2: " + ArrayLength2)
		While ArrayLength2 > 0
			ArrayLength2 -= 1
			String OutfitName = StorageUtil.StringListGet(none, "CNO_RegisteringOutfitSet_" + OutfitSetName, ArrayLength2)
			CNO_Log("[CNO] - OutfitSetName: " + OutfitSetName + " OutfitName: " + OutfitName)
			if StorageUtil.StringListHas(none, "CNO_InstalledOutfitList", OutfitName)
				CNO_Log("[CNO] - Adding: OutfitSetName: " + OutfitSetName + " OutfitName: " + OutfitName)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitSetList", OutfitSetName, false)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitSet_" + OutfitSetName, OutfitName, false)
				StorageUtil.StringListAdd(none, "CNO_InstalledOutfitList", OutfitSetName, False)
			endif
		endwhile
	endwhile
	
EndFunction

Function CNO_Log(String Text)
	if Mcm.EnableLog == True
		Debug.Trace(Text)
	endif
EndFunction
